/*
 * 
 * Copyright (c) 2013 Roman Putanowicz 
 * 
 * This file is distributed on "Simplified BSD License" as approved by 
 * the OSI Board. For licensing terms see LICENSE.BSD file distributed 
 * with this file.
 */

/*
 * Author: Roman Putanowicz <putanowr AT L5.pk.edu.pl>
 * Created: Wed Jul 17 10:31:14 2013
 * Modified by:
 */

/** 
 *  FIXME : describe the purpose of this file here
 */
#include "bs2vtk_config.h"
#include <stdlib.h> // for EXIT_SUCCESS
#include "bs2vtk_options.h" 
#include <iostream>

extern "C" {
#include "pkgeom.h"
#include "bsfile.h"
#include "bsm_Mesh.h"
}


int main_body(int argc, char **argv);

/** main function
 * 
 * This function should contain command line parsing and initialization
 * code. The real work should be done by calling main_body().
 */
int main(int argc, char **argv) {
  int result =  EXIT_SUCCESS;
  {
     int optct = optionProcess(&bs2vtkOptions, argc, argv);
     argc -= optct;
     argv += optct;
  }
  if (HAVE_OPT(DUMMY)) {
    std::cout << "Dummy option value: ";
    const char* val = OPT_ARG(DUMMY);
    std::cout << val << "\n";
  }

  pkv_InitScratchMem ( 256*1048576 ); /* allocate scratch memory pool, 256 MB */
  result = main_body(argc, argv);
  pkv_DestroyScratchMem ();

  return result;
}

/** The function where the main work is done after configuration
 * and command line parsing.
 */
int main_body(int argc, char **argv) {
  int result;
  BSMesh *mesh;

  mesh = bsm_NewMesh();

  bsm_ReadMesh(mesh, argv[0]);

  bsm_WriteMeshInfo(mesh, stdout);

  bsm_DeleteMesh(mesh);

  result = EXIT_SUCCESS;
  return result;
}
