
/* //////////////////////////////////////////////////// */
/* This file is a part of the BSTools procedure package */
/* written by Przemyslaw Kiciak.                        */
/* //////////////////////////////////////////////////// */

#ifdef XGLE_OPENGL_NEW


#define VERTEX_POS     0
#define VERTEX_COLOR   1
#define VERTEX_MARKING 2

#define BINDPOINT_TRANS (XGLE_LAST_BINDPOINT+1)
#define BINDPOINT_PROJ  (XGLE_LAST_BINDPOINT+2)
#endif

#ifdef XGLE_OPENGL_NEW
typedef struct {
    GLuint  p0;          /* 1st program handle */
    GLuint  sh0[3];      /* shader handles */
    GLuint  p1;          /* 2nd program handle */
    GLuint  sh1[2];      /* shader handles */
    GLuint  trbbuf;      /* transformation uniform block buffer */
    GLint   trbsize;     /* transformation uniform block size   */
    GLuint  trbi[2];     /* transformation uniform block index  */
    GLuint  trbind[2];   /* indices of transformation matrices  */
    GLint   trbofs[2];   /* offsets of transformation matrices  */
    GLuint  projbbuf[4]; /* projection uniform block buffers */
    GLint   projbsize;   /* projection uniform block size */
    GLuint  projbi[2];   /* projection uniform block index */
    GLuint  projbind[4]; /* indices of projection matrices  */
    GLint   projbofs[4]; /* offsets of projection matrices  */
  } my_gl_programs;

typedef struct {
    GLuint vao, vbo[2];
  } triangle_va;

extern my_gl_programs prog;
extern triangle_va tva;
#endif

void RysujOkno ( xge_widget *er, boolean onscreen );
void UpdateProjection ( int id, CameraRecf *CPos );
boolean OknoMsg ( xge_widget *er, int msg, int key, short x, short y );
int NearestPointFound ( CameraRecf *CPos, short x, short y );
void MoveCurrentPoint ( xge_widget *er, short x, short y );
void SelectPoints ( CameraRecf *CPos, int id,
                    short x0, short x1, short y0, short y1 );
void TransformPoints ( void );
int CallBack ( xge_widget *er, int msg, int key, short x, short y );
void init_edwin ( void );
void destroy_edwin ( void );

#ifdef XGLE_OPENGL_NEW
GLuint LoadShader ( GLenum shader_type, const char **filenames );
void InitGLMachinery ( void );
void DestroyGLMachinery ( void );
void LoadModelMatrix ( GLfloat model[16] );
void SelectProjection ( int id );
void LoadProjectionMatrices ( int id, GLfloat view[16], GLfloat projection[16],
                              GLfloat eyepos[4] );
void LoadVertices ( int nv, point3f *v );
void LoadVertex ( int n, point3f *v );
void LoadVMarkings ( int nv, byte *mk );
void LoadVMarking ( int vi, byte mk );

#endif

