
layout(triangles) in;
layout(triangle_strip,max_vertices=3) out;

in Vertex {
  vec4 Color;
} In[];

out NVertex {
  vec4 Color;
  vec3 Normal;
  vec3 Position;
} Out;

void main ( void )
{
  int  i;
  vec3 v1, v2;
  vec4 Pos, Normal;

  v1 = gl_in[1].gl_Position.xyz/gl_in[1].gl_Position.w -
       gl_in[0].gl_Position.xyz/gl_in[0].gl_Position.w;
  v2 = gl_in[2].gl_Position.xyz/gl_in[2].gl_Position.w -
       gl_in[0].gl_Position.xyz/gl_in[0].gl_Position.w;
  Normal.xyz = cross ( v1, v2 );
  Normal.w = 0.0;
  Pos = transform.InvTModelMatrix * Normal;
  v1 = normalize ( Pos.xyz );
  for ( i = 0; i < 3; i++ ) {
    Pos = transform.ModelMatrix * gl_in[i].gl_Position;
    gl_Position = project.VPMatrix * Pos;
    Out.Position = Pos.xyz / Pos.w;
    Out.Normal = v1;
    Out.Color = In[i].Color;
    EmitVertex ();
  }
  EndPrimitive ();
} /*main*/

