
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2009, 2017                            */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#include "pkvaria.h"
#include "pknum.h"
#include "pkgeom.h"
#include "camerad.h"
#include "multibs.h"
#include "pkscanner.h"
#include "bsfile.h"

#include "bsfprivate.h"

boolean bsf_ReadSpaceDim ( pks_scanner *sc, int maxdim, int *spdimen )
{
  if ( sc->nextsymbol != PKS_SYMB_INTEGER || sc->nextinteger > maxdim )
    return false;   
  *spdimen = sc->nextinteger;
  sc->GetNextSymbol ( sc );
  return true;
} /*bsf_ReadSpaceDim*/

boolean bsf_ReadCurveDegree ( pks_scanner *sc, int maxdeg, int *degree )
{
  if ( sc->nextsymbol != PKS_SYMB_INTEGER || sc->nextinteger > maxdeg )
    return false;   
  *degree = sc->nextinteger;
  sc->GetNextSymbol ( sc );
  return true;
} /*bsf_ReadCurveDegree*/

boolean bsf_ReadPatchDegree ( pks_scanner *sc, int maxdeg, int *udeg, int *vdeg )
{
  if ( sc->nextsymbol != PKS_SYMB_INTEGER || sc->nextinteger > maxdeg )
    return false;  
  *udeg = sc->nextinteger;
  sc->GetNextSymbol ( sc );
  if ( sc->nextsymbol != PKS_SYMB_INTEGER || sc->nextinteger > maxdeg )
    return false;   
  *vdeg = sc->nextinteger;
  sc->GetNextSymbol ( sc );
  return true;
} /*bsf_ReadPatchDegree*/

