
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2014, 2017                            */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#include "pkvaria.h"
#include "pknum.h"
#include "pkgeom.h"
#include "camerad.h"
#include "multibs.h"
#include "pkscanner.h"
#include "bsfile.h"

#include "bsfprivate.h"

void bsf_WriteDependencies ( bsf_Writer *writer,
                             int depname, int ndep, const int *dep )
{
  int i, k;
  int depid;

  switch ( depname ) {
case BSF_DEP_SPHERICAL:
    depid = BSF_KEY_SPHERICAL_PRODUCT;
    break;
default:
    return;
  }
/* ndep must be at least 1 */
  BSFwci
  writer->current_length += fprintf ( writer->output,
          "%s { ", bsf_keyword[depid] );
  for ( i = k = 0;  i < ndep-1;  i++, k++ ) {
    writer->current_length += fprintf ( writer->output, "%d,", dep[i] );
    BSFdol
    BSFwci
  }
  writer->current_length += fprintf ( writer->output, "%d }", dep[ndep-1] );
  BSFeol
} /*bsf_WriteDependencies*/

