
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2014, 2017                            */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#include "pkvaria.h"
#include "pknum.h"
#include "pkgeom.h"
#include "camerad.h"
#include "multibs.h"
#include "pkscanner.h"
#include "bsfile.h"

#include "bsfprivate.h"

/* ///////////////////////////////////////////////////////////////////////// */
void bsf_EndOutputLine ( bsf_Writer *writer )
{
  if ( writer->current_length > 0 )
    fprintf ( writer->output, "\n" );
  writer->current_length = 0;
  writer->newline = true;
} /*bsf_EndOutputLine*/

void bsf_WriteCurrentIndentation ( bsf_Writer *writer )
{
  if ( writer->newline ) {
    if ( writer->current_indentation > 0 ) {
      writer->current_length +=
        fprintf ( writer->output, "%*s", writer->current_indentation, "" );
      writer->newline = false;
    }
  }
} /*bsf_WriteCurrentIndentation*/

void bsf_DivideOutputLine ( bsf_Writer *writer )
{
  if ( writer->current_length >= BSF_OUTPUT_LINE_LENGTH+writer->current_indentation ) {
    bsf_EndOutputLine ( writer );
    bsf_WriteCurrentIndentation ( writer );
  }
  else {
    writer->current_length += fprintf ( writer->output, " " );
    writer->newline = false;
  }
} /*bsf_DivideOutputLine*/

