
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2015, 2017                            */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <malloc.h>
#include <string.h>

#include "pkvaria.h"


boolean pkv_AppendData ( char *buf, int buflength, int *bufptr,
                         char *data, int nbytes )
{
  int bp;

  bp = *bufptr;
  if ( bp + nbytes < buflength ) {
    if ( data )
      memcpy ( &buf[bp], data, nbytes );
    *bufptr = bp+nbytes;
    return true;
  }
  else
    return false;
} /*pkv_AppendData*/

boolean pkv_AppendDataR ( char **buf, int *bufsize, int *datasize, int sizestep,
                          char *bytes, int nbytes )
{
  char *auxp;
  int  newsize;

  if ( *bufsize - *datasize < nbytes ) {
    newsize = *bufsize + max ( sizestep, nbytes );
    if ( !(auxp = realloc ( *buf, newsize )) )
      return false;
    *buf = auxp;
    *bufsize = newsize;
  }
  else
    auxp = *buf;
  if ( bytes )
    memcpy ( &auxp[*datasize], bytes, nbytes );
  *datasize += nbytes;
  return true;
} /*pkv_AppendDataR*/

