
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2016                                  */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <math.h>
#include <memory.h>
#include <stdio.h>

#include "pkvaria.h"
#include "pkgeom.h"
#include "psout.h"

#include "psprivate.h"

void ps_HatchRect ( float w, float h, float x, float y, float ang, float d )
{
  point2f  a, b, c, e;
  vector2f v, z;
  float   t;
  
  while ( ang < 0.0 ) ang += PI;
  while ( ang > PI )  ang -= PI;
  SetVector2f ( &v, d*cos(ang), d*sin(ang) );
  if ( ang <= 0.5*PI ) {
    SetVector2f ( &z, -v.y, v.x );
    SetPoint2f ( &c, x+w, y );
    SetPoint2f ( &e, -w, h );
    SetVector2f ( &a, -w, 0.0 );
    OrtVector2f ( &z, &a, &a );
    SetVector2f ( &b, 0.0, h );
    OrtVector2f ( &z, &b, &b );
  }
  else {
    SetVector2f ( &z, v.y, -v.x );
    SetPoint2f ( &c, x, y );
    SetPoint2f ( &e, w, h );
    SetVector2f ( &a, 0.0, h );
    OrtVector2f ( &z, &a, &a );
    SetVector2f ( &b, w, 0.0 );
    OrtVector2f ( &z, &b, &b );
  }
  t = DotProduct2f ( &z, &e );
  for (;;) {
    if ( DotProduct2f ( &z, &a ) >= t )
      break;
    ps_Draw_Line ( c.x+a.x, c.y+a.y, c.x+b.x, c.y+b.y );
    AddVector2f ( &a, &z, &a );
    AddVector2f ( &b, &z, &b );
  }
} /*ps_HatchRect*/

