
/* ///////////////////////////////////////////////////////////////////////// */
/* This file is a part of the BSTools package                                */
/* written by Przemyslaw Kiciak                                              */
/* ///////////////////////////////////////////////////////////////////////// */
/* (C) Copyright by Przemyslaw Kiciak, 2016                                  */
/* this package is distributed under the terms of the                        */
/* Lesser GNU Public License, see the file COPYING.LIB                       */
/* ///////////////////////////////////////////////////////////////////////// */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#include "pkvaria.h"
#include "pknum.h"
#include "pkgeom.h"
#include "camera.h"

#include "xgedit.h"
#include "xgeprivate.h"


void xge_DrawHSVDialf ( xge_widget *er, boolean onscreen )
{
  short xc, yc, x, y, r;
  float *dialpos;
  
  dialpos = er->data0;
  r = (short)(XGE_HSVDIAL_W/2);
  xc = (short)(er->x + r - 1);
  yc = (short)(er->y + r - 1);
  if ( er->state == xgestate_TURNINGDIAL ) {
    x = XGE_HSVDIALICON_XA;
    y = XGE_HSVDIALICON_YA;
  }
  else {
    x = XGE_HSVDIALICON_XB;
    y = XGE_HSVDIALICON_YB;
  }
  XPutImage ( xgedisplay, xgepixmap, xgegc, _xge_canvas,
              x, y, er->x, er->y, XGE_HSVDIAL_W, XGE_HSVDIAL_H );
  x = (short)( xc + (r-5)*cos(*dialpos) );
  y = (short)( yc - (r-5)*sin(*dialpos) );
  xgeSetForeground ( xgec_WIDGET_FOREGROUND );
  xgeFillArc ( 7, 7, x-2, y-2, 0, 360*64 );

  if ( onscreen )
    xgeCopyRectOnScreen ( er->w, er->h, er->x, er->y );
} /*xge_DrawHSVDialf*/

xge_widget *xge_NewHSVDialf ( char window_num, xge_widget *prev, int id,
                              short x, short y, float *data )
{
  xge_widget *dial;

  if ( !_xge_InitHSVDialImages () )
    return NULL;
  dial = xge_NewDialf ( window_num, prev, id, XGE_HSVDIAL_W, XGE_HSVDIAL_H,
                        x, y, NULL, data );
  if ( dial )
    dial->redraw = xge_DrawHSVDialf;
  return dial;
} /*xge_NewHSVDialf*/

